# coding: utf-8

"""
    Coinbase Developer Platform APIs

    The Coinbase Developer Platform APIs - leading the world's transition onchain.

    The version of the OpenAPI document: 2.0.0
    Contact: cdp@coinbase.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from cdp.openapi_client.models.sign_evm_transaction_criteria_inner import SignEvmTransactionCriteriaInner
from cdp.openapi_client.models.sign_sol_transaction_criteria_inner import SignSolTransactionCriteriaInner
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

RULECRITERIA_ONE_OF_SCHEMAS = ["List[SignEvmTransactionCriteriaInner]", "List[SignSolTransactionCriteriaInner]"]

class RuleCriteria(BaseModel):
    """
    The set of criteria for the rule. There is a limit of 10 criteria per rule.
    """
    # data type: List[SignEvmTransactionCriteriaInner]
    oneof_schema_1_validator: Optional[List[SignEvmTransactionCriteriaInner]] = Field(default=None, description="A schema for specifying the rejection criteria for the SignEvmTransaction operation.")
    # data type: List[SignSolTransactionCriteriaInner]
    oneof_schema_2_validator: Optional[List[SignSolTransactionCriteriaInner]] = Field(default=None, description="A schema for specifying the rejection criteria for the SignSolTransaction operation.")
    actual_instance: Optional[Union[List[SignEvmTransactionCriteriaInner], List[SignSolTransactionCriteriaInner]]] = None
    one_of_schemas: Set[str] = { "List[SignEvmTransactionCriteriaInner]", "List[SignSolTransactionCriteriaInner]" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = RuleCriteria.model_construct()
        error_messages = []
        match = 0
        # validate data type: List[SignEvmTransactionCriteriaInner]
        try:
            instance.oneof_schema_1_validator = v
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # validate data type: List[SignSolTransactionCriteriaInner]
        try:
            instance.oneof_schema_2_validator = v
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in RuleCriteria with oneOf schemas: List[SignEvmTransactionCriteriaInner], List[SignSolTransactionCriteriaInner]. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in RuleCriteria with oneOf schemas: List[SignEvmTransactionCriteriaInner], List[SignSolTransactionCriteriaInner]. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into List[SignEvmTransactionCriteriaInner]
        try:
            # validation
            instance.oneof_schema_1_validator = json.loads(json_str)
            # assign value to actual_instance
            instance.actual_instance = instance.oneof_schema_1_validator
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into List[SignSolTransactionCriteriaInner]
        try:
            # validation
            instance.oneof_schema_2_validator = json.loads(json_str)
            # assign value to actual_instance
            instance.actual_instance = instance.oneof_schema_2_validator
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into RuleCriteria with oneOf schemas: List[SignEvmTransactionCriteriaInner], List[SignSolTransactionCriteriaInner]. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into RuleCriteria with oneOf schemas: List[SignEvmTransactionCriteriaInner], List[SignSolTransactionCriteriaInner]. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], List[SignEvmTransactionCriteriaInner], List[SignSolTransactionCriteriaInner]]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


